// 
//      SLOVNI HODINY
//    MILOS ZAJIC, PECKY, 2018
// -------------------------------

#include "FastLED.h"
#include <Wire.h>
#include "RTClib.h"
#include <EEPROM.h>

#define NUM_LEDS 210
#define DATA_PIN 2
#define on color
#define off CRGB::Black
CRGB leds[NUM_LEDS];  //pole led a barev
CRGB color;

uint32_t colortab [16] = {0xFF0000, 0x00FF00, 0x0000FF, 0xFFFFFF,
                          0xFFFF00, 0xFF00FF, 0x00FFFF, 0xFF8000,
                          0xFF0080, 0x80FF00, 0x00FF80, 0x8000FF,
                          0x0080FF, 0xFF8080, 0x80FF80, 0x8080FF,
                         };
const int pintl1 = 5;
const int pintl2 = 6;
const int tl1 = 0;
const int tl2 = 1;
const int TL_PIN[] = {pintl1, pintl2};
unsigned long tblik;
boolean blik = false;
boolean zmena = false;


uint8_t setmode = 0; //mod nastavovani
uint8_t hod = 1;
uint8_t min = 0;
uint8_t  jmin = 0;  //jednotky minut
uint8_t  barva_h = 0;
uint8_t  barva_m = 0;
uint8_t  barva_a = 0;
uint8_t  jas = 50;
int tstisk = 0;     //doba stisku tl2
int eebarva_h = 10;
int eebarva_m = 11;
int eebarva_a = 12;

// vytvoření instance DS1307 z knihovny RTClib
RTC_DS1307 DS1307;


#define DISP_JE leds[0]=on; leds[1]=on;
#define DISP_JSOU leds[2]=on; leds[3]=on; leds[4]=on; leds[5]=on;

#define DISP_1HOD leds[6]=on; leds[7]=on; leds[8]=on; leds[9]=on; leds[10]=on;
#define DISP_2HOD leds[27]=on; leds[28]=on; leds[29]=on;
#define DISP_3HOD leds[34]=on; leds[35]=on; leds[36]=on;
#define DISP_4HOD leds[22]=on; leds[23]=on; leds[24]=on; leds[25]=on; leds[26]=on;
#define DISP_5HOD leds[19]=on; leds[20]=on; leds[21]=on;
#define DISP_6HOD leds[11]=on; leds[12]=on; leds[13]=on; leds[14]=on;
#define DISP_7HOD leds[15]=on; leds[16]=on; leds[17]=on; leds[18]=on;
#define DISP_8HOD leds[57]=on; leds[58]=on; leds[59]=on;
#define DISP_9HOD leds[30]=on; leds[31]=on; leds[32]=on; leds[33]=on; leds[34]=on;
#define DISP_10HOD leds[52]=on; leds[53]=on; leds[54]=on; leds[55]=on; leds[56]=on;
#define DISP_11HOD leds[37]=on; leds[38]=on; leds[39]=on; leds[40]=on; leds[41]=on;leds[42]=on; leds[43]=on; leds[44]=on;
#define DISP_12HOD leds[45]=on; leds[46]=on; leds[47]=on; leds[48]=on; leds[49]=on;leds[50]=on; leds[51]=on;

#define DISP_HODIN leds[60]=on; leds[61]=on; leds[62]=on; leds[63]=on; leds[64]=on;
#define DISP_HODINA leds[60]=on; leds[61]=on; leds[62]=on; leds[63]=on; leds[64]=on; leds[65]=on;
#define DISP_HODINY leds[66]=on; leds[67]=on; leds[68]=on; leds[69]=on; leds[70]=on; leds[71]=on;

#define DISP_1MIN leds[115]=on; leds[116]=on; leds[117]=on; leds[118]=on; leds[119]=on;
#define DISP_DVEMIN leds[102]=on; leds[103]=on; leds[104]=on;
#define DISP_DVAMIN leds[128]=on; leds[129]=on; leds[130]=on;
#define DISP_3MIN leds[177]=on; leds[178]=on; leds[179]=on;
#define DISP_4MIN leds[110]=on; leds[111]=on; leds[112]=on; leds[113]=on; leds[114]=on;
#define DISP_5MIN leds[207]=on; leds[208]=on; leds[209]=on;
#define DISP_6MIN leds[139]=on; leds[140]=on; leds[141]=on; leds[142]=on;
#define DISP_7MIN leds[150]=on; leds[151]=on; leds[152]=on; leds[153]=on;
#define DISP_8MIN leds[158]=on; leds[159]=on; leds[160]=on;
#define DISP_9MIN leds[105]=on; leds[106]=on; leds[107]=on; leds[108]=on; leds[109]=on;
#define DISP_10MIN leds[190]=on; leds[191]=on; leds[192]=on; leds[193]=on; leds[194]=on;
#define DISP_11MIN leds[120]=on; leds[121]=on; leds[122]=on; leds[123]=on; leds[124]=on; leds[125]=on; leds[126]=on; leds[127]=on;
#define DISP_12MIN leds[128]=on; leds[129]=on; leds[130]=on; leds[131]=on; leds[132]=on; leds[133]=on; leds[134]=on;
#define DISP_13MIN leds[173]=on; leds[174]=on; leds[175]=on; leds[176]=on; leds[177]=on; leds[178]=on; leds[179]=on;
#define DISP_14MIN leds[143]=on; leds[144]=on; leds[145]=on; leds[146]=on; leds[147]=on; leds[148]=on; leds[149]=on;
#define DISP_15MIN leds[166]=on; leds[167]=on; leds[168]=on; leds[169]=on; leds[170]=on; leds[171]=on; leds[172]=on;
#define DISP_16MIN leds[135]=on; leds[136]=on; leds[137]=on; leds[138]=on; leds[139]=on; leds[140]=on; leds[141]=on; leds[142]=on;
#define DISP_17MIN leds[150]=on; leds[151]=on; leds[152]=on; leds[153]=on; leds[154]=on; leds[155]=on; leds[156]=on; leds[157]=on;
#define DISP_18MIN leds[158]=on; leds[159]=on; leds[160]=on; leds[161]=on; leds[162]=on; leds[163]=on; leds[164]=on;
#define DISP_19MIN leds[180]=on; leds[181]=on; leds[182]=on; leds[183]=on; leds[184]=on; leds[185]=on; leds[186]=on; leds[187]=on; leds[188]=on; leds[189]=on;
#define DISP_20MIN leds[90]=on; leds[91]=on; leds[92]=on; leds[93]=on; leds[94]=on; leds[95]=on;
#define DISP_30MIN leds[95]=on; leds[96]=on; leds[97]=on; leds[98]=on; leds[99]=on; leds[100]=on;
#define DISP_40MIN leds[75]=on; leds[76]=on; leds[77]=on; leds[78]=on; leds[79]=on; leds[80]=on; leds[81]=on; leds[82]=on;
#define DISP_50MIN leds[83]=on; leds[84]=on; leds[85]=on; leds[86]=on; leds[87]=on; leds[88]=on; leds[89]=on;

#define DISP_MINUTY  leds[195]=on; leds[196]=on; leds[197]=on; leds[198]=on; leds[199]=on; leds[200]=on;
#define DISP_MINUT leds[196]=on; leds[197]=on; leds[198]=on; leds[199]=on; leds[200]=on;
#define DISP_MINUTA leds[201]=on; leds[202]=on; leds[203]=on; leds[204]=on; leds[205]=on; leds[206]=on;
#define DISP_A leds[73]=on;

//=======================================================================

void setup() {
  Serial.begin(9600);
  FastLED.addLeds<WS2812B, DATA_PIN, GRB>(leds, NUM_LEDS);
  pinMode(pintl1, INPUT);
  pinMode(pintl2, INPUT);
  digitalWrite(pintl1, HIGH);
  digitalWrite(pintl2, HIGH);

  if (! DS1307.begin()) {
    Serial.println("Hodiny nejsou pripojeny!");
    while (1);
  }
  barva_h = EEPROM.read (eebarva_h);
  barva_m = EEPROM.read (eebarva_m);
  barva_a = EEPROM.read (eebarva_a);
}
void loop() {
  color = colortab[barva_h];

  FastLED.setBrightness(50);
  DateTime datumCas = DS1307.now();
  //Serial.print(datumCas.hour());
  //Serial.print(':');
  //Serial.println(datumCas.minute());

  if (stisk(tl1) && setmode >= 1) {
    delay (300);
    if (setmode < 6) setmode++;
    else setmode = 1;
  }
  switch (setmode) {

    case 0: //zakladni rezim
      hod = datumCas.hour();
      if (hod > 12) hod = hod - 12;
      min = datumCas.minute();
      ZOBHOD ();
      ZOBMIN ();
      zmena = false;
      delay (50);
      stisk(tl2);
      if (tstisk > 10) {
        DISP_CLS();
        FastLED.show();
        delay (800);
        ZOBHOD ();
        FastLED.show();
        while (stisk(tl2) == true)
          setmode = 1;
      }
      else setmode = 0;
      break;

    case 1:   //nastav hod
      if (stisk(tl2)) {
        zmena = true;
        if (hod <= 11) hod++;
        else hod = 1;
      }
      ZOBHOD ();
      break;
    case 2:   //nastav min
      if (stisk(tl2)) {
        zmena = true;
        if (min < 59) min++;
        else min = 0;
      }
      ZOBMIN();
      {
        DISP_MINUT
      } //aby se neco zobrazilo bylo kdyz je cela hod
      break;
    case 3:   //barva hod
      if (stisk(tl2)) {
        if (barva_h < 15) barva_h++;
        else barva_h = 0;
        EEPROM.write(eebarva_h, barva_h);
      }
      DISP_COLOR();
      ZOBHOD();
      break;

    case 4:   //barva A
      if (stisk(tl2)) {
        if (barva_a < 15) barva_a++;
        else barva_a = 0;
        EEPROM.write(eebarva_a, barva_a);
      }
      DISP_COLOR();
      color = colortab[barva_a];
      leds[73] = on;
      break;

    case 5:   // barva min
      if (stisk(tl2)) {
        if (barva_m < 15) barva_m++;
        else barva_m = 0;
        EEPROM.write(eebarva_m, barva_m);
      }
      DISP_COLOR();
      ZOBMIN();
      break;

    case 6:   //ukonceni nastaveni
      stisk(tl2);
      if (tstisk > 10) {
        setmode = 0;
        DISP_CLS();
        FastLED.show();
        delay (500);
        while (stisk(tl2) == true);
      }
      ZOBHOD ();
      ZOBMIN ();
      if (zmena) {
        DS1307.adjust(DateTime(2018, 4, 26, hod, min, 0));
      }
      break;
  }
  if (tstisk > 1) {
    blik = true;
    delay (50);
  }  //autorepeat
  else if (tstisk == 1)
    delay(400);

  if (tblik < millis()) {
    tblik = millis() + 500;
    blik = !blik;
  }
  setjas();
  if (blik == true && setmode >= 1) (jas = 80);
  if (blik == false && setmode >= 1) (jas = 40);
  FastLED.setBrightness(jas);
  FastLED.show();
  DISP_CLS();
}

//_______________________________________________________________________

void DISP_CLS()
{ for (int i = 0; i < NUM_LEDS; i++) {
    leds[i] = off;
  }
}

void setjas() {
  int puvjas = jas;
  int pom = (1023 - analogRead(A0));
  pom = pom / 4;
  if (pom > 32) (pom = pom - 30); else pom = 2; //posun nuly
  if (pom > 255) (pom = 255);
  if (pom > puvjas + 1) (puvjas = puvjas + 1); //hystereze a zmena
  if (pom < puvjas - 1) (puvjas = puvjas - 1);
  jas = puvjas;
}

void DISP_COLOR() {
  color = colortab[0]; //oznac rezim barev
  leds[14] = on;
  color = colortab[1];
  leds[15] = on;
  color = colortab[2];
  leds[44] = on;
}

void JEDN_MIN() {
  if (jmin == 1) {
    DISP_1MIN
  }
  if (jmin == 2)
    if (min == 2) {
      DISP_DVEMIN
    }
    else {
      DISP_DVAMIN
    }
  if (jmin == 3) {
    DISP_3MIN
  }
  if (jmin == 4) {
    DISP_4MIN
  }
  if (jmin == 5) {
    DISP_5MIN
  }
  if (jmin == 6) {
    DISP_6MIN
  }
  if (jmin == 7) {
    DISP_7MIN
  }
  if (jmin == 8) {
    DISP_8MIN
  }
  if (jmin == 9) {
    DISP_9MIN
  }
}

void ZOBHOD() {
  color = colortab[barva_h];
  if ( (hod == 1) || (hod >= 5 && hod <= 12 )) {
    DISP_JE
  }
  else {
    DISP_JSOU
  }
  if (hod == 1) {
    DISP_1HOD
  }
  if (hod == 2) {
    DISP_2HOD
  }
  if (hod == 3) {
    DISP_3HOD
  }
  if (hod == 4) {
    DISP_4HOD
  }
  if (hod == 5) {
    DISP_5HOD
  }
  if (hod == 6) {
    DISP_6HOD
  }
  if (hod == 7) {
    DISP_7HOD
  }
  if (hod == 8) {
    DISP_8HOD
  }
  if (hod == 9) {
    DISP_9HOD
  }
  if (hod == 10) {
    DISP_10HOD
  }
  if (hod == 11) {
    DISP_11HOD
  }
  if (hod == 12) {
    DISP_12HOD
  }
  if ((hod >= 5 && hod <= 12 )) {
    DISP_HODIN
  }
  else if (hod == 1) {
    DISP_HODINA
  }
  else {
    DISP_HODINY
  }
}
void  ZOBMIN() {
  color = colortab[barva_a];
  if  (min == 0) {}
  else {
    {
      DISP_A
    }
    color = colortab[barva_m];
    jmin = min;
    JEDN_MIN();
    if (min == 10) {
      DISP_10MIN
    }
    if (min == 11) {
      DISP_11MIN
    }
    if (min == 12) {
      DISP_12MIN
    }
    if (min == 13) {
      DISP_13MIN
    }
    if (min == 14) {
      DISP_14MIN
    }
    if (min == 15) {
      DISP_15MIN
    }
    if (min == 16) {
      DISP_16MIN
    }
    if (min == 17) {
      DISP_17MIN
    }
    if (min == 18) {
      DISP_18MIN
    }
    if (min == 19) {
      DISP_19MIN
    }
    if ( min >= 20 && min <= 29 )
    { DISP_20MIN
      jmin = min - 20;
      JEDN_MIN();
    }
    if ( min >= 30 && min <= 39 )
    { DISP_30MIN
      jmin = min - 30;
      JEDN_MIN();
    }
    if ( min >= 40 && min <= 49 )
    { DISP_40MIN
      jmin = min - 40;
      JEDN_MIN();
    }
    if ( min >= 50 && min <= 59 )
    { DISP_50MIN
      jmin = min - 50;
      JEDN_MIN();
    }

    if (min == 1) {
      DISP_MINUTA
    }
    else if (min >= 2 && min <= 4 ) {
      DISP_MINUTY
    }
    else {
      DISP_MINUT
    }
  }
}

boolean stisk(int idtl) {
  if (digitalRead(TL_PIN[idtl]) == LOW)  {
    delay (20);
    if (digitalRead(TL_PIN[idtl]) == LOW) {
      if (idtl == tl2) tstisk ++;
      return true;
    }
  }
  if (idtl == tl2) tstisk = 0;
  return false;
}

// KONEC  
// XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
